% !TeX spellcheck = en_GB

\begin{itemize}
	\item read: \url{https://de.mathworks.com/help/wavelet/ug/wavelet-scattering.html}
\end{itemize}

Scattering is a signal processing technique which allows the extraction of multi-scale features from data. Basis for the scattering transform are wavelets which are applied at different scales and orientations. The different scales allow for capturing low- and high-frequency details, while the changed orientations can capture features with specific directions, like trends.\footnote{\url{https://de.mathworks.com/help/wavelet/ug/wavelet-scattering.html}}



\subsection{Wavelet}
Wavelets are short, non-periodic, finite supported (meaning mostly zero) waveforms that are localized in time and frequency domain. They are used for analysing and processing signals which have a frequency and time characteristic. By applying wavelet transform, a signal is decomposed into those single wavelets at different scales and positions. 

\begin{itemize}
	\item add a spectogram! will ask about this one for sure. \url{https://www.kymat.io/gallery_1d/plot_synthetic.html#sphx-glr-gallery-1d-plot-synthetic-py}
	\item advantage for real world signals who are not periodic but change their frequency over time, also good for abrupt changes
	\item Multiresolution analysis
	\item \textbf{talk about filterbank}
\end{itemize}


By decomposing a signal into wavelets at different scales and orientations, the obtained coefficients can be used as features to analyse the signal.

\begin{itemize}
	\item show filter stuff: \url{https://www.kymat.io/gallery_1d/plot_filters.html#sphx-glr-gallery-1d-plot-filters-py}
	\item only after that show scattering result!
\end{itemize}

The basic approach for the scattering transform is shown in figure \ref{img:scattering_transform_lecture}. An input signal is first scaled using a scaling filter $\phi$, which results in the zeroth order coefficients. The scaling filter, which can be seen as a low-pass filter, is used to extract the low-frequency components of the signal. Concolving the input signal with the scaling filter can be written as:
$$
(x \ast h) (t) = \int_{-\infty}^{\infty} x(\tau) h(t - \tau) d\tau
$$
% TODO: change symbols to same as in image
which basically represents a sliding of the scaling filter over each point of the signal, resulting in a pointwise product at each point. The resulting zeroth order coefficients gives an approximation of the input signal at the corresponding scale, see also figure \ref{img:scattering_zeroth_order}.

Convolving the resulting signal with the first-order wavelet filter $\psi_{\lambda}^{(1)}$ results in the first order coefficients. The first order coefficients capture the high-frequency information of the signal, see also figure \ref{img:scattering_first_order}.


The result is then convolved with multiple wavelet filter $\psi_{\lambda}^{(1)}$. The result is then scaled again and convolved with a second wavelet filter $\psi_{\mu}^{(2)}$. The result is a set of coefficients which are used as features for the signal.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/scattering_transform_lecture.png}
	\caption{}
	\label{img:scattering_transform_lecture}
\end{figure}



Using the kymatio scattering python library, a scattering transform implementation by Andreux et al\cite{JMLR:v21:19-047}, the scattering coefficients of a sample \gls{ECG} signal can be extracted.\footnote{\url{https://www.kymat.io}}

The 1D scattering transform can be displayed as follows:\footnote{\url{https://www.kymat.io/codereference.html}}
$$
S_J x = [S_J^{(0)}x, S_J^{(1)}x, S_J^{(2)}x]
$$
with 
$$
S_J^{(0)}x (t) = x \ast \phi_J (t)
$$
$$
S_J^{(1)} x (t, \lambda) = |x \ast \psi_{\lambda}^{(1)}|  \ast \phi_J
$$
$$
S_J^{(2)} x (t, \lambda, \mu) = ||x \ast \psi_{\lambda}^{(1)}| \ast \psi_{\mu}^{(2)}| \ast \phi_J
$$
with the used wavelet being a morlet wavelet.



% correct link, making problems: /gallery_1d/plot_real_signal.html#sphx-glr-gallery-1d-plot-real-signal-py
For applying the scattering transform, the signal length, number of scales and number of wavelets per octave need to be specified. The transformation itself is a cascade of wavelet transforms and modulus operations. 

% J: The maximum log-scale of the scattering transform. In other words, the maximum scale is given by 2^J
% Q: By default, Q (int) is the number of wavelets per octave for the first order. The second-order wavelets always have one wavelet per octave
% shape: The length of the input signals.
%

% scattering
% the output is in the form of a np.ndarray or size (B, C, N1), where N1 is the signal length after subsampling to the scale (with the appropriate oversampling factor to reduce aliasing), and C is the number of scattering coefficients
% 

The result is a set of coefficients which are used as features for the signal with the ouput being of shape $(P, T/2^J)$ where:\footnote{\url{https://www.kymat.io/userguide.html}}
\begin{itemize}
	\item $P$ is the number of scattering coefficients, which value is roughly proportional to: $1 + JQ + J(J-1)Q/2 = $
	\item $T$ is the length of the signal
	\item $J$ is the number of scales
\end{itemize}

The first order coefficients capture the low-frequency information, while the second order coefficients capture the high-frequency information. The zeroth order coefficients are the original, averaged signal itself. Figure \ref{img:scattering_original_signal} shows the original \gls{ECG} signal, while figures \ref{img:scattering_zeroth_order}, \ref{img:scattering_first_order} and \ref{img:scattering_second_order} show the zeroth, first and second order coefficients of the scattering transform.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/scattering_original_signal.png}
	\caption{}
	\label{img:scattering_original_signal}
\end{figure}


\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/scattering_zeroth_order.png}
	\caption{}
	\label{img:scattering_zeroth_order}
\end{figure}


\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/scattering_first_order.png}
	\caption{}
	\label{img:scattering_first_order}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/scattering_second_order.png}
	\caption{}
	\label{img:scattering_second_order}
\end{figure}